<template>
    <div class="modal fade" id="modalNewCheckin" tabindex="-1" aria-labelledby="modalNewCheckin" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-header">
                    <h1 class="modal-title fs-5">Check-In</h1>
                    <button type="button" class="btn-close" id="btn-close-checkin" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    <div class="d-flex flex-column gap-3">
                        <div>
                            <label for="reservation" class="form-label">Reserva</label>
                            <select class="form-select" aria-label="reservation" v-model="selectedReservation" @focus="listReservations">
                                <option :value="undefined" selected disabled>Selecione a reserva</option>
                                <option v-for="room in reservations" :key="room" :value="room.id">{{ room.room }} - {{ room.guest }}</option>
                            </select>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancelar</button>
                    <button type="button" class="btn btn-primary" @click="doCheckin">Finalizar</button>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import ServiceAPI from '@/services/ServiceAPI'

export default {
    name: 'ModalNewCheckin',
    data: () => ({
        reservations: [],
        selectedReservation: undefined
    }),
    methods: {
        listReservations() {
            ServiceAPI.getReservationsByStatus('RESERVADO')
                .then((response) => {
                    this.reservations = response.data
                })
        },
        doCheckin() {
            ServiceAPI.setReservationStatus(this.selectedReservation, 'OCUPADO')
                .then(() => {
                    this.clearInputs()
                    this.$store.commit('setAlert', {
                        alert: true,
                        messageAlert: "Check-In realizado com sucesso!",
                        error: false                        
                    })
                    this.close()
                }).finally(() => {
                    this.$store.commit('refreshInfos')
                })
        },
        clearInputs() {
            this.selectedReservation = undefined
        },
        close() {
            document.getElementById("btn-close-checkin").click()
        }
    }
}
</script>

<style scoped>

</style>
